/* All Rights reserved */


#import <AppKit/AppKit.h>
#import "LedgerModel.h"

@interface ExpDocument : NSDocument

{
  id tableView;
  id total;
  id average;
  id defaultDateButton;
  
  id totalLabel;
  id averageLabel;
  
  LedgerModel *ledger;
  NSMutableDictionary *filter;
}


- (void) dealloc;
- (id) init;


// Instance methods
//******************


- (void) inputPanelDayChanged: (NSNotification *) not;
- (void) updateTotal: (NSNotification *) aNotification;
- (void) updateFilter: (NSNotification *) aNotification;
- (void) addEntry: (id) sender;


// NSDocument override methods
//*****************************


- (NSData *) dataRepresentationOfType: (NSString *) type;
- (BOOL) loadDataRepresentation: (NSData *) data ofType: (NSString *) type;
- (void) windowControllerDidLoadNib: (NSWindowController *) controller;
- (NSString *) windowNibName;


// NSWindow delegate methods
//***************************


- (void) windowDidBecomeKey: (NSNotification *)aNotification;


@end
